"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const _file = __importStar(require("./file"));
const store_1 = require("../store");
const errors_1 = require("../errors");
function useDangerousUDFHelpers(pass, opts) {
    // addUDFHelper Function existence check
    if (
    // @ts-ignore
    typeof pass.file['addUDFHelper'] === 'function' ||
        // @ts-ignore
        typeof pass.file['listUDFHelper'] === 'function') {
        // @ts-ignore
        if (!pass.file['__use_babel_udf_helpers__']) {
            throw new errors_1.AlreadyImplementedError(`
This tool cannot be used. officially supported.
Please see the official documentation.
https://babeljs.io/docs/en/babel-helpers
`);
        }
        else {
            /**
             * MEMO:
             *
             * It will be redined for pass.file,
             * but it is not stored in pass, so substitute
             *
             * Perhaps behaviorally,
             * a new instance of babel.PluginPass will be updated for each plugin,
             * but babel.BabelFile behaves like being reused.
             *
             */
            setHelpersInStore(opts);
            defineUDFHelpersFuncForPluginPass(pass);
            return;
        }
    }
    else {
        setHelpersInStore(opts);
        Object.defineProperty(pass.file, '__use_babel_udf_helpers__', {
            enumerable: true,
            value: true,
        });
        Object.defineProperty(pass.file, 'addUDFHelper', {
            enumerable: true,
            get: function addUDFHelper() {
                return _file.addUDFHelper.bind(pass.file);
            },
        });
        Object.defineProperty(pass.file, 'listUDFHelper', {
            enumerable: true,
            get: function listUDFHelper() {
                return _file.listUDFHelper.bind(pass.file);
            },
        });
        defineUDFHelpersFuncForPluginPass(pass);
    }
}
exports.default = useDangerousUDFHelpers;
function defineUDFHelpersFuncForPluginPass(pass) {
    Object.defineProperty(pass, 'addUDFHelper', {
        enumerable: true,
        get: function addUDFHelper() {
            return pass.file['addUDFHelper'];
        },
    });
    Object.defineProperty(pass, 'listUDFHelper', {
        enumerable: true,
        get: function addUDFHelper() {
            return pass.file['listUDFHelper'];
        },
    });
}
function setHelpersInStore(opts) {
    const helpers = opts['helpers'];
    if (helpers) {
        /**
         * Support import default and named
         *
         * import * as helpers from './helpers'
         * import helpers from './helpers'
         */
        Object.assign(store_1.helpers, helpers.default ? helpers.default : helpers);
    }
    else {
        throw new errors_1.NotFoundError('Not found UDF helpers.');
    }
}
//# sourceMappingURL=index.js.map
